diff -ur mozilla/xpfe/communicator/resources/content/contentAreaClick.js /home/colin/download/mozilla/xpfe/communicator/resources/content/contentAreaClick.js
--- mozilla/xpfe/communicator/resources/content/contentAreaClick.js	Wed Apr 10 05:40:33 2002
+++ /home/colin/download/mozilla/xpfe/communicator/resources/content/contentAreaClick.js	Fri Apr 19 17:15:44 2002
@@ -177,13 +177,26 @@
     }
     return true;
   }
+  
+  function isNewWinModifier(event) {
+    switch (pref.getIntPref("ui.key.new_window_modifier")) {
+      case 0:
+        return event.ctrlKey;
+      case 1:
+        return event.altKey;
+      case 2:
+        return event.metaKey;
+      default:
+        return event.ctrlKey;
+    }
+  }
 
   function handleLinkClick(event, href, linkNode)
   {
     var theTab, loadInBackground;
     switch (event.button) {                                   
       case 0:                                                         // if left button clicked
-        if (event.metaKey || event.ctrlKey) {                         // and meta or ctrl are down
+        if (isNewWinModifier(event)) {                                // and modifier is for new window
           if (pref && pref.getBoolPref("browser.tabs.opentabfor.middleclick") && getBrowser && 
             getBrowser() && getBrowser().localName == "tabbrowser") {
             
@@ -217,8 +230,6 @@
           saveURL(href, linkNode ? gatherTextUnder(linkNode) : "");
           return true;
         }
-        if (event.altKey)                                             // if alt is down
-          return true;                                                // do nothing
         return false;
       case 1:                                                         // if middle button clicked
         if (pref && pref.getBoolPref("browser.tabs.opentabfor.middleclick") && getBrowser && 
diff -ur mozilla/xpfe/components/prefwindow/resources/content/pref-smart_browsing.xul /home/colin/download/mozilla/xpfe/components/prefwindow/resources/content/pref-smart_browsing.xul
--- mozilla/xpfe/components/prefwindow/resources/content/pref-smart_browsing.xul	Wed Apr 10 05:42:29 2002
+++ /home/colin/download/mozilla/xpfe/components/prefwindow/resources/content/pref-smart_browsing.xul	Fri Apr 19 17:13:00 2002
@@ -48,7 +48,7 @@
   var _elementIDs = ["browserRelatedDisabledForDomains", "addDomain",
                      "browserGoBrowsingEnabled", "browserAutoCompleteEnabled",
                      "browserUrlbarAutoFill", "browserUrlbarShowPopup", "browserUrlbarShowSearch",
-                     "browserUrlbarMatchOnlyTyped"];
+                     "browserUrlbarMatchOnlyTyped","browserNewWindowModifier"];
   
   ]]>
   </script>
@@ -125,6 +125,21 @@
             prefstring="browser.urlbar.showSearch"/>
       <data id="browserUrlbarMatchOnlyTyped" preftype="bool" prefattribute="value"
             prefstring="browser.urlbar.matchOnlyTyped"/>
+    </hbox>
+  </groupbox>
+  <groupbox>
+    <caption label="&newWinModifierHeader.label;"/>
+   
+    <hbox align="center">
+      <label value="&newWinModifier.label;"/>
+      <menulist id="browserNewWindowModifier" 
+                prefstring="ui.key.new_window_modifier">
+        <menupopup>
+          <menuitem value="0" label="Control"/>
+          <menuitem value="1" label="Alt"/>
+          <menuitem value="2" label="Meta"/>
+        </menupopup>
+      </menulist>
     </hbox>
   </groupbox>
 </page>
diff -ur mozilla/xpfe/components/prefwindow/resources/locale/en-US/pref-smart_browsing.dtd /home/colin/download/mozilla/xpfe/components/prefwindow/resources/locale/en-US/pref-smart_browsing.dtd
--- mozilla/xpfe/components/prefwindow/resources/locale/en-US/pref-smart_browsing.dtd	Wed Apr 10 05:42:39 2002
+++ /home/colin/download/mozilla/xpfe/components/prefwindow/resources/locale/en-US/pref-smart_browsing.dtd	Fri Apr 19 17:13:00 2002
@@ -41,3 +41,5 @@
 <!ENTITY  autoCompleteMatchOnlyTyped.label       "Match only websites you've typed previously">
 <!ENTITY  autocompletePreview.label              "Preview">
 
+<!ENTITY  newWinModifierHeader.label             "New windows">
+<!ENTITY  newWinModifier.label                   "Modifier to use to open new windows/tabs">